
#include "stdafx.h"
#include "peter.h"
#include "IconBuf.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

////////////////////////////////////////////////////////////////////
// Pozor - linky BMP pro 256 barev jsou zarovnvny na 4 bajty !
//       - linky BMP pro 2 barvy (maska) jsou zarovnny na bajt !
////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////
// konstruktor a destruktor

CIconBuf::CIconBuf()
{
	m_Data = (unsigned char*)malloc(5);		// data ikon
	ASSERT(m_Data != NULL);
	m_Mask = (unsigned char*)malloc(5);		// data masky ikon
	ASSERT(m_Mask != NULL);
	m_Num = 0;								// poet ikon v bufferu
	m_Width = 32;							// implicitn ka jedn ikony
	m_Height = 32;							// implicitn vka jedn ikony
}

CIconBuf::~CIconBuf()
{
	free(m_Data);
	free(m_Mask);
}

/////////////////////////////////////////////////////////////////////////////
// pidn ikon z resource (num = poet, id = identifiktor)

BOOL CIconBuf::Load(int num, int id)
{
// pprava star a nov dlky linky
	int OldLine = (m_Width*m_Num+3) & ~0x3;			// pvodn dlka linky
	int AddLine = (m_Width*num+3) & ~0x3;			// dlka pidvan linky
	int NewLine = (m_Width*(m_Num+num)+3) & ~0x3;	// nov dlka linky
	int i;											// ta

// nastaven velikosti bufferu dat ikon
	unsigned char* buff;
	buff = (unsigned char*)realloc(m_Data, NewLine*m_Height);
	if (buff == NULL) return FALSE;
	m_Data = buff;

// nalezen resource bitmapy
	HRSRC hRes = ::FindResource(AfxGetResourceHandle(),
		MAKEINTRESOURCE(id), RT_BITMAP);
	ASSERT(hRes != NULL);

// naten bitmapy do pamti
	HGLOBAL hData = ::LoadResource(AfxGetResourceHandle(), hRes);
	ASSERT(hData != NULL);

// naten dat bitmapy do bufferu
	BITMAPINFO* bmp = (BITMAPINFO*) ::LockResource(hData);
	ASSERT((bmp->bmiHeader.biWidth) == (int)(m_Width*num));

// roztaen linek existujcch ikon v bufferu
	if (m_Num > 0)
	{
		for (i = m_Height-1; i >= 0; i--)
			memmove(m_Data + i*NewLine, m_Data + i*OldLine, OldLine);
	}

// penesen dat linek bitmapy
	for (i = 0; i < m_Height; i++)
	{
		memcpy(m_Data + i*NewLine + m_Width*m_Num, 
			(unsigned char*)&(bmp->bmiColors[256]) + i*AddLine, AddLine);
	}
	m_Num += num;

// vygenerovn masky ikon
	return GenerMask();
}

/////////////////////////////////////////////////////////////////////////////
// vygenerovn masky ikon

BOOL CIconBuf::GenerMask()
{
	ASSERT(m_Data != NULL);
	int linka = (m_Width*m_Num+3) & ~0x3;	// dlka linky barevn bitmapy
	int delka = m_Height*linka;				// dlka dat barevn bitmapy
	unsigned char* buffsrc = m_Data;		// buffer dat barevn bitmapy
	unsigned char* buffdst;					// buffer dat masky bitmapy

// nastaven velikosti bufferu masky ikon
	buffdst = (unsigned char*)realloc(m_Mask, ((m_Width*m_Num+7)/8)*m_Height);
	if (m_Num == 0)
	{
		m_Mask = buffdst;
		return TRUE;
	}
	if (buffdst == NULL) return FALSE;
	m_Mask = buffdst;

// vygenerovn dat masky
#ifdef _X86_
	_asm
	{
	push	eax
	push	ebx
	push	ecx
	push	esi
	push	edi

	cld
	mov		esi,buffsrc						// buffer dat barevn bitmapy
	mov		edi,buffdst						// buffer masky bitmapy
	mov		ebx,linka						// dlka linky barevn bitmapy
	mov		ecx,delka						// dlka dat barevn bitmapy celkem
	add		esi,ecx							// konec dat za barevnou bitmapou
	sub		esi,ebx							// adresa posledn linky bitmapy
	mov		ah,1							// stada bit

X1:	lodsb									// naten bajtu barevn bitmapy
	cmp		al,1							// je platn barva ?
	rcl		ah,1							// pznakov bit
	jnc		X2								// nen jet 8 bit
	mov		al,ah							// stada bit
	stosb									// uloen bajtu masky
	mov		ah,1							// nov stada masky

X2:	dec		ebx								// ta bajt na lince
	jnz		X4								// nen jet konec linky
	mov		ebx,linka						// nov ta dlky linky
	sub		esi,ebx							// nvrat adresy zatku linky
	sub		esi,ebx							// adresa zatku pedel linky

	cmp		ah,1							// je zapoat dal bajt ?
	je		X4								// nen zapoat dal bajt
X3:	shl		ah,1							// rotace masky na dal bitovou pozici
	jnc		X3								// nen jet konec masky
	stosb									// uloen bajtu masky
	mov		ah,1							// nov stada masky

X4:	loop	X1								// dal bajt dat

	pop		edi
	pop		esi
	pop		ecx
	pop		ebx
	pop		eax
	}
#else
	unsigned char* src = buffsrc + delka - linka; // adresa posledn linky bitmapy
	unsigned char* dst = buffdst;			// buffer masky bitmapy
	unsigned char stradac = 0;				// stada bit masky
	short cit8 = 8;							// ta bit masky
	int citlin = linka;						// ta dlky linky

	for (int citac = delka; citac != 0; citac--)
	{
		stradac <<= 1;						// rotace stadae na dal pozici
		if (src[0] == 0)					// je platn barva ?
			stradac |= 1;					// pznak pozad
		src++;								// zven ukazatele dat bitmapy

		cit8--;								// ta bit stadae
		if (cit8 == 0)						// jsou ji vechny bity stadae ?
		{
			dst[0] = stradac;				// uloen stadae bit masky
			dst++;							// zven ukldac adresy masky
			cit8 = 8;						// nov ta bit masky
		}

		citlin--;							// ita bajt na lince
		if (citlin == 0)					// je ji konec linky ?
		{
			citlin = linka;					// nov ta dlky linky
			src -= citlin;					// nvrat adresy zatku linky
			src -= citlin;					// adresa zatku pedel linky
	
			if (cit8 < 8)					// je zapoat dal bajt staae ?
			{
				while (cit8 != 0)			// cyklus pro chybjc bity masky
				{
					cit8--;					// snen bit stadae
					stradac <<= 1;			// rotace stadae na dal pozici
				}
				dst[0] = stradac;			// uloen stadae bit masky
				dst++;						// zven ukldac adresy masky
				cit8 = 8;					// nov ta bit masky
			}

		}
	}
#endif

	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// pidn ikon do seznamu ikon

void CIconBuf::AddList(CImageList* list)
{
	HDC dc;
	HBITMAP bitmap;
	CBitmap bmp, bmpMono;
	HPALETTE OldPal;

// vytvoen MONO bitmapy
	bmpMono.CreateBitmap(m_Width*m_Num, m_Height, 1, 1, m_Mask);

// oteven DC displeje
	dc = ::GetDC(0);
	ASSERT(dc != NULL);

// vbr a realizace vlastnch palet 
	OldPal = ::SelectPalette(dc, StdPalette, FALSE);
	::RealizePalette(dc);

// pprava zhlav BMP
	StdBitmapInfo->bmiHeader.biWidth = m_Width*m_Num;
	StdBitmapInfo->bmiHeader.biHeight = m_Height;

// vytvoen bitmapy
	bitmap = ::CreateDIBitmap(dc,&(StdBitmapInfo->bmiHeader),
		CBM_INIT, m_Data,StdBitmapInfo,DIB_RGB_COLORS);
	ASSERT(bitmap != NULL);

// pidn bitmapy k seznamu
	bmp.m_hObject = bitmap;
	list->Add(&bmp, &bmpMono);	
	
// uvolnn palet a DC displeje
	::SelectPalette(dc,OldPal,TRUE);
	::ReleaseDC(0,dc);
}

