
//////////////////////////////////////////////////////
//          !!!!!!!!!!!!!!!!!!!!!!!!!				//
//   Nastavit zarovnvn pekladae na 4 Bajty,	//
//  aby souhlasilo zarovnvn struktur v souboru	//
//	        !!!!!!!!!!!!!!!!!!!!!!!!!				//
//////////////////////////////////////////////////////

// Pi zmn velikosti poloek bude mon nutn zmnit
// zarovnn a na 1 Bajt, proto radji dodret velikosti
// poloek pro vt zarovnn.

/////////////////////////////////////////////////////////////////////////////
// inicializan tabulky obsah pol (8 B)

typedef struct tagINITBUF {
	signed short int	refer;		// (2) index reference (-1 = nen)
	signed short int	parent;		// (2) hladina prvku (k uren rodie)
	unsigned short int	model;		// (2) model (typ) prvku
	unsigned short int	param;		// (2) parametry (pidat PR_INTERNAL !!!!)
} INITBUF;

/////////////////////////////////////////////////////////////////////////////
// definice indexu datovho bloku (32 B)

typedef struct tagPETINDEX {
	long int			delka;		// (4) dlka datovho bloku
	long int			pocet;		// (4) poet poloek v datovm bloku
	char				jmeno[8];	// (8) jmno datovho bloku (8 znak)
	long int			extra1;		// (4) doplujc informace 1 (= 0)
									//      - potek okna, jazyk text, ikony WIDTH
	long int			extra2;		// (4) doplujc informace 2 (= 0)
									//		- kurzor, kd znak text, ikony HEIGHT
	long int			extra3;		// (4) doplujc informace 3 (= 0)
	long int			extra4;		// (4) doplujc informace 4 (= 0)
} PETINDEX;

/////////////////////////////////////////////////////////////////////////////
// definice zhlav souboru (16 + 13*32 B)

#define SIZEOFPETHEAD 16			// zkladn velikost zhlav (bez index)

typedef struct tagPETHEAD {
	char				ident[3];	// (3) identifikace = "PET"
	unsigned char		verze;		// (1) verze = 1
	unsigned long int	param;		// (4) parametry = 0
	long int			data;		// (4) offset zatku dat v souboru (= dlka zhlav)
	long int			pocet;		// (4) poet datovch blok
	PETINDEX			pi[13];		// tabulka index
#define	piImport		pi[0]		// (32) blok "IMPORT" - import internch prvk (seznam ASCIIZ jmen)
#define	piClass			pi[1]		// (32) blok "CLASS" - tdy
#define	piGlobal		pi[2]		// (32) blok "GLOBAL" - globln objekty
#define	piLocal			pi[3]		// (32) blok "LOCAL" - lokln objekty
#define	piProgram		pi[4]		// (32) blok "PROGRAM" - program (obsah funkc)
#define	piReal			pi[5]		// (32) blok "REAL" - obsah selnch promnnch
#define	piText			pi[6]		// (32) blok "TEXT" - texty (text 0 = jmno programu)
#define	piPalette		pi[7]		// (32) blok "PALETTE" - palety ve formtu BMP
#define	piPic16			pi[8]		// (32) blok "PICTURE" - obrzky 16*16 (obrzek 0 = ikona programu)
#define	piPic32			pi[9]		// (32) blok "PICTURE" - obrzky 32*32 (obrzek 0 = ikona programu)
#define	piMap			pi[10]		// (32) blok "MAP" - mapy ploch
#define	piSound			pi[11]		// (32) blok "SOUND" - zvuky
#define	piMusic			pi[12]		// (32) blok "MUSIC" - hudba
} PETHEAD;

/////////////////////////////////////////////////////////////////////////////
// definice poloky programu nebo struktury (12 B) - pozor na zarovnn dat programu !!!

#define PETPROG_CHILDS	0x01		// pznak, e jsou potomci
#define PETPROG_NEXT	0x02		// pznak, e bude potomek stejn hladiny
#define PETPROG_EXP		0x04		// pznak rozvinut potomk
#define PETPROG_BOLD	0x08		// pznak zvraznn textu
#define PETPROG_GRAY	0x10		// pznak zeedl poloky
#define PETPROG_LOCK	0x20		// pznak uzamen poloky proti modifikaci

typedef struct tagPETPROG {
	unsigned short int	param;		// (2) parametry (viz ve)
	signed short int	typ;		// (2) blok s deklarac (-1 = nen)
	signed short int	refer;		// (2) index s deklarac (-1 = nen)
	signed short int	index;		// (2) index s daty (-1 = implicitn)
	signed short int	icon;		// (2) ikona (-1 = implicitn)
	signed short int	name;		// (2) text jmna (-1 = implicitn)
} PETPROG;

////////////////////////////////////////////////////////////////////
// okno programovn

class CProg : public CFormView
{
protected:
	CProg();
	DECLARE_DYNCREATE(CProg)

public:
	//{{AFX_DATA(CProg)
	enum { IDD = IDR_PROG };
	CStatic	m_Refer;
	CButton		m_Lock;			// uzamen funkce
	CButton		m_Off;			// vypnut funkce
	CButton		m_Def;			// implicitn obsah funkce
	CButton		m_Icon;			// editace ikony
	CEdit		m_Name;			// jmno funkce
	CStatic		m_Nadpis1;		// nadpis nad stromem veejnch objekt
	CStatic		m_Nadpis2;		// nadpis nad stromem loklnch objekt
	CStatic		m_Nadpis3;		// nadpis nad stromem zkladnch prvk
	CStatic		m_Nadpis4;		// nadpis nad stromem td objekt
	CTreeCtrl	m_Object;		// strom veejnch objekt
	CTreeCtrl	m_Local;		// strom loklnch objekt
	CTreeCtrl	m_Struc;		// strom zkladnch prvk a struktur
	CTreeCtrl	m_Class;		// strom td objekt
	CTreeCtrl	m_Edit;			// strom editace
	CStatic		m_Split1;		// lev vertikln rozdlova
	CStatic		m_Split2;		// lev horizontln rozdlova
	CStatic		m_Split3;		// prav vertikln rozdlova
	CStatic		m_Split4;		// prav horizontln rozdlova
	//}}AFX_DATA

// aktivn poloka a aktivn strom
	int			m_AktItem;		// aktivn poloka (v aktivnm okn) (-1 = nen)
	int			m_AktBufID;		// ID aktivnho bufferu
	CTreeCtrl*	m_AktTree;		// aktivn strom
	
	BOOL		m_FilName;		// probh plnn eidtoru jmna textem

// seznamy ikon k zobrazen pro stromy
	CImageList* m_Ico16;		// mal ikony 16x16
	CImageList* m_Ico32;		// velk ikony 32x32

// seznamy text
	CTextBuf	m_Text;			// uivatelsk texty
	CTextBuf	m_TextInt;		// texty internch funkc

//	CStringArray m_Text;		// uivatelsk texty
//	CStringArray m_TextInt;		// texty internch funkc

// buffery ikon a obrzk
	CIconBuf	m_BufIco16Int;	// buffer ikon 16x16 - intern funkce
	CIconBuf	m_BufIco32Int;	// buffer ikon 32x32 - intern funkce
	CIconBuf	m_BufIco16;		// buffer ikon 16x16 - uivatelsk ikony
	CIconBuf	m_BufIco32;		// buffer ikon 32x32 - uivatelsk ikony

// buffery struktury programu
	CProgBuf	m_Buf[PROGBUFNUM];	// buffery struktury programu

// nemnit poad - muselo by se zmnit t pi ukldn souboru !
#define BufIntID 0					// buffer internch funkc (nem strom)
#define BufClsID 1					// buffer td objekt
#define BufObjID 2					// buffer veejnch objekt
#define BufLocID 3					// buffer loklnch objekt
#define BufEdiID 4					// buffer editace
#define BufStrID 5					// buffer zkladnch prvk a struktur

#define m_BufInt m_Buf[BufIntID]	// buffer internch funkc (nem strom)
#define m_BufCls m_Buf[BufClsID]	// buffer td objekt
#define m_BufObj m_Buf[BufObjID]	// buffer veejnch objekt
#define m_BufLoc m_Buf[BufLocID]	// buffer loklnch objekt
#define m_BufEdi m_Buf[BufEdiID]	// buffer editovan funkce
#define m_BufStr m_Buf[BufStrID]	// buffer zkladnch prvk a struktur

// obsluha taen
	BOOL		m_Dragging;			// pznak probhajciho taen

	CTreeCtrl*	m_TreeSrc;			// ukazatel na strom zdroje taen
	int			m_DragSrc;			// identifiktor ID stromu zdroje taen
	HTREEITEM	m_itemDrag;			// taen prvek
	int			m_itemDragN;		// index taenho prvku
	int			m_itemDragPar;		// parametry taenho prvku
	int			m_itemDragModel;	// model taenho prvku

	CTreeCtrl*	m_TreeDst;			// ukazatel na strom cle taen
	int			m_DragDst;			// identifiktor ID stromu cle taen (-1=neplatn)
	HTREEITEM	m_itemDrop;			// clov prvek (rodi)
	int			m_itemDropN;		// index clovho prvku (rodie, -1=root)
	int			m_itemDropPar;		// parametry clovho prvku (rodie)
	int			m_itemDropModel;	// model clovho prvku (rodie)
	int			m_DropIndex;		// index pozice k uloen (-1 = zkaz uloen)

	CImageList*	m_DragList;			// seznam obrzk pro taen
	CSize		m_HotSpot;			// bod uchycen taenho prvku
	CSize		m_TestSpot;			// bod testu taen prvku
	BOOL		m_DragRight;		// taeno pravm tlatkem (koprovn m pednost)
	BOOL		m_DragCopy;			// je koprovn nebo pesun (jinak jen ruen)
	BOOL		m_DragDelete;		// je ruen nebo pesun (pi pesunu nebo ruen)
	HCURSOR		m_OldCursor;		// uschovan kurzor ped taenm
	HCURSOR		m_CurCopy;			// kurzor koprovn
	HCURSOR		m_CurMove;			// kurzor pesunu
	HCURSOR		m_CurNoDrag;		// zkaz taen
	HCURSOR		m_CurDelete;		// taen se zruenm
	HCURSOR		m_CurAkt;			// aktivn kurzor pi operaci

// obsluha ukldn/natn souboru
	BOOL		m_Saving;			// probh ukldn/natn souboru
	PETHEAD*	m_Head;				// zhlav souboru
	DWORD		m_Writen;			// poet uloench/natench bajt v jedn operaci
	HANDLE		m_File;				// handle souboru
	BOOL		m_OK;				// pznak operace OK
	CString		m_FileName;			// jmno souboru

	PETPROG*	m_bufClass;			// buffer prvk td
	int			m_numClass;			// poet prvk td
	PETPROG*	m_bufObject;		// buffer prvk globlnch objekt
	int			m_numObject;		// poet prvk globlnch objekt
	PETPROG*	m_bufLocal;			// buffer prvk loklnch objekt
	int			m_numLocal;			// poet prvk loklnch objekt
	PETPROG*	m_bufEdit;			// buffer prvk editoru funkc
	int			m_numEdit;			// poet prvk editoru

	int*		m_tabImport;		// konverzn tabulka importovanch funkc
	char*		m_bufImport;		// buffer text importovanch funkc
	int			m_maxImport;		// velikost bufferu importovanch funkc
	int			m_numImport;		// poet importovanch funkc v bufferu
	int			m_sizeImport;		// velikost dat v bufferu importovanch funkc

	char*		m_bufText;			// buffer text
	int			m_maxText;			// velikost bufferu text
	int			m_numText;			// poet text v bufferu text
	int			m_sizeText;			// velikost dat v bufferu text

	signed short int* m_typImport;	// konverzn tabulka typ importu
	signed short int* m_refImport;	// konverzn tabulka referenc importu

public:

	//{{AFX_VIRTUAL(CProg)
	public:
	virtual void OnInitialUpdate();
	virtual BOOL PreTranslateMessage(MSG* pMsg);
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);
	virtual void OnDraw(CDC* pDC);
	//}}AFX_VIRTUAL

protected:
	virtual ~CProg();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:
	//{{AFX_MSG(CProg)
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnBeginDragProgObj(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnBeginDragProgLoc(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnBeginDragProgStr(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnBeginDragProgCls(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnBeginDragProgEdi(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnRButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnItemExpandedProgObj(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnItemExpandedProgLoc(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnItemExpandedProgStr(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnItemExpandedProgCls(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnItemExpandedProgEdi(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnSetFocusObject(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnSetFocusLocal(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnSetFocusStruc(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnSetFocusClass(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnSetFocusProg(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnChangeName();
	afx_msg void OnProgDef();
	afx_msg void OnSelChangedObject(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnSelChangedLocal(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnSelChangedStruc(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnSelChangedClass(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnSelChangedEdit(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnDblclkProgObject(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnDblclkProgLocal(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnFileSave();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

	void OnButtonUp();
	void OnItemExpandedProg(NMHDR* pNMHDR, LRESULT* pResult, int buff);
	int CopyItem(int& nSrc, int& nDst, int nPar);
	void InitPrgBuf(int num, const INITBUF* InitBuf, CProgBuf* ProgBuf);
	BOOL SrcDropWin(CPoint point);
//	BOOL TestDropWin();
	BOOL TestDropItem(int srcModel, int srcPar, int srcBuff, int dstModel, 
		int dstPar, int dstBuff, int dstItem);
	void OnSetFocus(NMHDR* pNMHDR, LRESULT* pResult);
	void DispName();
	void OnBeginDragProg(NMHDR* pNMHDR, LRESULT* pResult);
	void AktNameTree(CProgBuf* buff, CString* text, int AktBuf, int AktItem);
	void OnSelChanged(NMHDR* pNMHDR, LRESULT* pResult);
	void RefSelChange(int AktBuf, int RefBuf);
	void DblclkObject(int item);
	void DblclkLocal(int item);
	void SavePrg(PETPROG* buf, int buffID);
	void SaveWriteFile(LPCVOID buf, DWORD bytes);
	void OnFileLoad();
	void LoadReadFile(LPVOID buf, DWORD bytes);
	int LoadSrcIndex(LPCTSTR jmeno, int beg);
	void FileLoadHead();
	void FileLoadImport();
	void FileLoadText();
	void FileLoadPic();
	void FileLoadProg(LPCTSTR jm, PETPROG*& pbuf, int& pnum, CProgBuf* buf);
	void FileLoadTab();
};
