
#define	PROGBUFNUM 6				// poet buffer

////////////////////////////////////////////////////////////////////
// definice poloky programu (28 bajt)

typedef struct tagPROGITEM {
	unsigned short int	param;	// parametry
	unsigned short int	model;	// model (typ) prvku
	signed short int	typ;	// blok s deklarac (-1 = nen)
	signed short int 	refer;	// index deklarace (-1 = nen)
	signed short int	data;	// blok s daty (-1 = nen)
	signed short int	index;	// index dat (-1 = nen)
	signed short int	parent;	// index rodie ve stromu (-1 = nen)
	signed short int	childs;	// poet pmch potomk v podvtvi (0 = nejsou)
	signed short int	items;	// poet prvk v podvtvi vetn tohoto prvku
	signed short int	icon;	// index ikony poloky (-1 = implicitn)
	signed short int	name;	// index textu jmna poloky (-1 = implicitn)
	HTREEITEM			htree;	// handle poloky ve stromu (NULL = nen)
	signed short int	counter; // ta odkaz na tento prvek
} PROGITEM;

// pznaky
#define PR_EXP			0x0001	// parametr - pznak rozvinut potomk
#define PR_BOLD			0x0002	// parametr - zvraznn psmo
#define PR_GRAY			0x0004	// parametr - zeednut
#define PR_LOCK			0x0008	// parametr - uzameno proti modifikaci
#define PR_ONE			0x0010  // prvek me mt maximln 1 potomka (log. negace)
#define PR_INTERNAL		0x0020	// zkaz ruen a pesunu - vchoz prvek (po kopii se nuluje)
#define PR_NOMOVE		0x0040	// zkaz ruen, koprovn a pesouvn prvku (potomek struktury)
#define PR_GROUP		0x0080	// prvek je skupina - mus bt prchoz pro parametry
#define PR_LIST			0x0100	// prvek je seznam
#define PR_FUNC			0x0200	// funkce (obsah je v bufferu funkc)
#define PR_GET_COMMAND	0x0400	// pijm pkazy
#define PR_AS_COMMAND	0x0800	// me bt pouito jako pkaz
#define PR_GET_EXPRES	0x1000	// pijm vrazy
#define PR_AS_EXPRES	0x2000	// me bt pouito jako vraz
#define PR_GET_BOOL		0x4000	// pijm logick vraz
#define PR_AS_BOOL		0x8000	// me bt pouito jako logick vraz

// modely (typy) prvk
#define	TYP_NONE		0			// neznm funkce
#define TYP_IGROUP		TYP_NONE+1	// intern skupina (nelze koprovat)
#define	TYP_GROUP		TYP_NONE+2	// skupina
#define	TYP_LIST		TYP_NONE+3	// seznam
#define TYP_ROOT		TYP_NONE+4	// fiktivn ROOT prvek okna
#define TYP_IPARAM		TYP_NONE+5	// vstupn parametr
#define TYP_OPARAM		TYP_NONE+6	// vstupn parametr
#define	TYP_NONE_		TYP_NONE+7

#define	TYP_IF			TYP_NONE_	// konstrukce IF
#define	TYP_IF_TEST		TYP_IF+1	// test podmnky IF
#define	TYP_IF_YES		TYP_IF+2	// podmnka IF splnna
#define	TYP_IF_NO		TYP_IF+3	// podmnka IF nesplnna
#define	TYP_IF_			TYP_IF+4

#define	TYP_WHILE		TYP_IF_		// konstrukce WHILE
#define	TYP_WHILE_TEST	TYP_WHILE+1	// test podmnky WHILE
#define	TYP_WHILE_BODY	TYP_WHILE+2	// tlo WHILE
#define	TYP_WHILE_BREAK	TYP_WHILE+3	// peruen WHILE
#define	TYP_WHILE_		TYP_WHILE+4

#define	TYP_CASE		TYP_WHILE_	// konstrukce CASE
#define	TYP_CASE_EXPR	TYP_CASE+1	// vraz pro CASE
#define	TYP_CASE_ON		TYP_CASE+2	// vtev CASE
#define	TYP_CASE_TEST	TYP_CASE+3	// test vtve CASE
#define	TYP_CASE_DEF	TYP_CASE+4	// implicitn vtev CASE
#define	TYP_CASE_		TYP_CASE+5

#define	TYP_NUM			TYP_CASE_	// seln konstanta
#define	TYP_CIS			TYP_NUM+1	// slice
#define	TYP_TECKA		TYP_NUM+2	// desetinn teka
#define	TYP_MINUS		TYP_NUM+3	// znamnko v sle
#define	TYP_EXPONENT	TYP_NUM+4	// exponent sla
#define TYP_TXT			TYP_NUM+5	// textov konstanta
#define	TYP_NUM_		TYP_NUM+6

#define	TYP_OPER		TYP_NUM_	// matematick opertor
#define	TYP_COMP		TYP_OPER+1	// porovnvac opertor
#define	TYP_ANDOR		TYP_OPER+2	// logick opertor
#define TYP_EQU_TEXT	TYP_OPER+3	// shodnost text
#define TYP_EQU_PIC		TYP_OPER+4	// shodnost obrzk
#define	TYP_OPER_		TYP_OPER+5

#define	TYP_FUNC		TYP_OPER_	// uivatelsk funkce
#define	TYP_REAL		TYP_FUNC+1	// seln promnn
#define	TYP_BOOL		TYP_FUNC+2	// logick promnn
#define	TYP_TEXT		TYP_FUNC+3	// textov promnn
#define	TYP_PIC			TYP_FUNC+4	// promnn s obrzkem
#define TYP_MAP			TYP_FUNC+5	// promnn s mapou
#define	TYP_SND			TYP_FUNC+6	// promnn se zvukem
#define	TYP_MUS			TYP_FUNC+7	// promnn s hudbou
#define	TYP_SPRITE		TYP_FUNC+8	// promnn se sprajtem
#define	TYP_DIALOG		TYP_FUNC+9	// promnn s dialogem
#define TYP_EVENT		TYP_FUNC+10	// promnn s udlost
#define	TYP_CLASS		TYP_FUNC+11	// obecn tda
#define	TYP_FUNC_		TYP_FUNC+12

#define	TYP_F			TYP_FUNC_	// intern funkce - jen jako pkaz bez parametr
#define	TYP_FN			TYP_F+1		// intern funkce - vrac slo
#define	TYP_FNN			TYP_F+2		// intern funkce - vrac i pijm slo
#define	TYP_FNT			TYP_F+3		// intern funkce - vrac slo, pijm text
#define	TYP_F0N			TYP_F+4		// intern funkce - pijm slo
#define	TYP_FT			TYP_F+5		// intern funkce - vrac text
#define	TYP_FTN			TYP_F+6		// intern funkce - vrac text, pijm slo
#define	TYP_FTT			TYP_F+7		// intern funkce - vrac text, pijm text
#define	TYP_FTNT		TYP_F+8		// intern funkce - vrac text, pijm slo a text
#define	TYP_FB			TYP_F+9		// intern funkce - vrac logickou hodnotu
#define	TYP_FBN			TYP_F+10	// intern funkce - vrac logickou hodnotu, pijm slo
#define	TYP_FBB			TYP_F+11	// intern funkce - vrac i pijm logickou hodnotu
#define	TYP_F_			TYP_F+12

#define	TYP_			TYP_F_		// poet typ celkem (ponechat posledn !!!!!)

////////////////////////////////////////////////////////////////////
// tda bufferu programu

class CProgBuf : public CObject
{
public:
	CProgBuf();
	virtual ~CProgBuf();

	int			m_BufID;		// ID bufferu
	PROGITEM*	m_Items;		// buffer poloek
	int			m_Num;			// poet poloek v bufferu
	int			m_Max;			// maximln poloek v bufferu
	int			m_First;		// prvn zobrazen poloka bufferu
	int			m_Next;			// nsledujc (nezobrazen) poloka bufferu
	CTreeCtrl*	m_Tree;			// odkaz na zobrazen strom (NULL = nen)
	CProgBuf*	m_ProgBuf;		// mapa vech buffer programu
	CTextBuf*	m_Text;			// seznam text (sdlen)

// vloen poloky do bufferu (vrac opraven index)
	int Insert(PROGITEM* item, int Index = -1);

// nalezen poloky podle handle (vrac index)
	int SrcItem(HTREEITEM hItem);

// zruen poloky z bufferu
	void Delete(int Index);

// pekreslen stromu
	void ReDisp();

};
